=== debian/changelog ===
xtensor (0.24.2-2) unstable; urgency=medium

  * debian patch docs_mathjax.patch configures docs to use local
    mathjax files. Build-Depends-Indep: libjs-mathjax
  * xsimd/complex/batch errors are resolved by xtensor 0.24 with
    xsimd 8.1.0-3. Closes: #994246, #994248, #1013625.

 -- Drew Parsons <dparsons@debian.org>  Sat, 25 Jun 2022 11:23:11 +0200

xtensor (0.24.2-1) unstable; urgency=medium

  * New upstream release.
    - applies debian patch install_headers_PR2462.patch

 -- Drew Parsons <dparsons@debian.org>  Sat, 25 Jun 2022 00:36:27 +0200

xtensor (0.24.0-1exp1) experimental; urgency=medium

  * New upstream release.
    - applies debian patches doctest_PR2405.patch,
      test_EXPECT_DOUBLE_EQ_PR2436.patch, doc_sphinx_API.patch
    - Depends (Recommends): libxsimd-dev (>= 8.0.3~)
  * update debian/watch to the latest github pattern
  * debian patch install_headers_PR2462.patch applies upstream PR#2462
    to fix installation of headers.

 -- Drew Parsons <dparsons@debian.org>  Mon, 22 Nov 2021 21:54:42 +0100
