## xtensor 0.24.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,7 +59,7 @@
 endif()
 
 if(XTENSOR_USE_XSIMD)
-    set(xsimd_REQUIRED_VERSION 8.0.2)
+    set(xsimd_REQUIRED_VERSION 9.0.1)
     if(TARGET xsimd)
         set(xsimd_VERSION ${XSIMD_VERSION_MAJOR}.${XSIMD_VERSION_MINOR}.${XSIMD_VERSION_PATCH})
         # Note: This is not SEMVER compatible comparison
