=== debian/changelog ===
xtensor (0.24.3-2ubuntu1) mantic; urgency=medium

  * Hardcode clang-15 for the clang autopkg test.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 30 Jul 2023 13:40:14 +0200

xtensor (0.24.3-2) unstable; urgency=medium

  * debian patch gcc13_test_precision.patch fixes test failures
    triggered by precision changes in gcc-13. Closes: #1041372.

 -- Drew Parsons <dparsons@debian.org>  Thu, 27 Jul 2023 00:10:32 +0200

xtensor (0.24.3-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.1
  * debian patch revert_xsimd8_undo_PR2573.patch reverts upstream
    PR2573 (commit 5d1026e) to drop xsimd requirement from 9 back to 8.
    xsimd 9 is not yet packaged for debian, and new xsimd 9 features
    are not yet used in xtensor anyway.

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Nov 2022 11:57:03 +0100
