=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  python3-sphinx-rtd-theme <!nodoc>,
  graphviz <!nodoc>,
  libjs-mathjax <!nodoc>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/science-team/xtensor
 Vcs-Git: https://salsa.debian.org/science-team/xtensor.git
 Homepage: https://github.com/xtensor-stack/xtensor
@@ -73,6 +73,7 @@
  .
  This package provides the documentation.
 Build-Profiles: <!nodoc>
+Multi-Arch: foreign
 
 Package: xtensor-dev
 Architecture: all
