=== debian/tests/control ===
Tests: test-xtensor
Depends: cmake,
         g++,
         doctest-dev,
         libxtensor-dev,
         libxsimd-dev (>= 8.0.3~) [amd64 kfreebsd-any]
Restrictions: allow-stderr

Tests: test-xtensor-clang
Depends: clang-15,
         cmake,
         doctest-dev,
         libxtensor-dev,
         libxsimd-dev (>= 8.0.3~) [amd64 kfreebsd-any]
Restrictions: allow-stderr
