## xtensor 0.24.7

=== debian/changelog ===
xtensor (0.24.7-4) unstable; urgency=medium

  * include !ppc64el in libxsimd-dev upper version for debian/tests

 -- Drew Parsons <dparsons@debian.org>  Mon, 16 Oct 2023 10:39:41 +0200

xtensor (0.24.7-3) unstable; urgency=medium

  * restrict xsimd tests to [!arm64 !armel !armhf ppc64el !riscv64
    !s390x] xsimd gives errors on arm (neon) Bug#1053090, and on other
    arches marked as XSIMD_NO_SUPPORTED_ARCHITECTURE, Bug#1053854.
    Essentially xsimd support is only available on amd64 and i386 at
    the moment.
  * clean deprecated build restrictions in debian/rules

 -- Drew Parsons <dparsons@debian.org>  Fri, 13 Oct 2023 10:43:55 +0200

xtensor (0.24.7-2) unstable; urgency=medium

  * debian/tests: apply upper bound Depends: libxsimd-dev (<< 11)
    cf. upstream Issue#2721. xtensor has a strict version dependency
    on xsimd, if used. Not appropriate to apply to the package itself
    since Recommends is optional anyway. Closes: #1052882.

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Oct 2023 14:30:32 +0200

xtensor (0.24.7-1) unstable; urgency=medium

  * New upstream release.
  * debian patch test_xinfo_no_clang.patch disables the test_xinfo
    test for Clang >= 16. See upstream Issue #2694. Closes: #1042560.
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Sep 2023 01:47:44 +0200

xtensor (0.24.6-1exp2) experimental; urgency=medium

  * push debian patch gcc13_test_precision.patch to experimental

 -- Drew Parsons <dparsons@debian.org>  Thu, 27 Jul 2023 12:54:29 +0200

xtensor (0.24.6-1exp1) experimental; urgency=medium

  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Fri, 24 Mar 2023 23:41:18 +0100

xtensor (0.24.5-1exp1) experimental; urgency=medium

  * New upstream release.
  * Run tests with xsimd 10. Test with xsimd 10 on arm64.
    Closes: #1027990.
  * debian/tests: use dpkg-query to test if xsimd is installed
    (to set XTENSOR_USE_XSIMD)
  * tests now more stable for less common architectures.
    Closes: #985699.

 -- Drew Parsons <dparsons@debian.org>  Wed, 22 Feb 2023 16:38:37 +0100

xtensor (0.24.4-1exp1) experimental; urgency=medium

  * New upstream release.
    - versioned Build-Depends: libxsimd-dev (>= 10.0.0~)
      Drop debian patch revert_xsimd8_undo_PR2573.patch
    - applies debian patch test_findpackage_after_project.patch
    - bump versioned Depends: xtl-dev (>= 0.7.5~)
  * set libxtensor-dev Architecture: all, now installs config files
    to /usr/share

 -- Drew Parsons <dparsons@debian.org>  Tue, 07 Feb 2023 00:12:09 +0100
