=== debian/control ===
--- 
+++ 
@@ -8,27 +8,27 @@
  dpkg-dev (>= 1.17.14),
  doctest-dev <!nocheck>,
  nlohmann-json3-dev (>= 3.1.1~),
- xtl-dev (>= 0.7.0~), xtl-dev (<< 0.8),
- libxsimd-dev (>= 8.0.3~) [amd64 kfreebsd-any],
+ xtl-dev (>= 0.7.5~), xtl-dev (<< 0.8),
+ libxsimd-dev (>= 10.0.0~) [!arm64 !armel !armhf !ppc64el !riscv64 !s390x],
  python3-sphinx
 Build-Depends-Indep: python3-breathe <!nodoc>,
  python3-sphinx <!nodoc>,
  python3-sphinx-rtd-theme <!nodoc>,
  graphviz <!nodoc>,
  libjs-mathjax <!nodoc>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/xtensor
 Vcs-Git: https://salsa.debian.org/science-team/xtensor.git
 Homepage: https://github.com/xtensor-stack/xtensor
 
 Package: libxtensor-dev
-Architecture: any
-Multi-Arch: same
+Architecture: all
+Multi-Arch: foreign
 Section: libdevel
-Depends: xtl-dev (>= 0.7.0~), xtl-dev (<< 0.8),
+Depends: xtl-dev (>= 0.7.5~), xtl-dev (<< 0.8),
  nlohmann-json3-dev (>= 3.1.1~),
  ${misc:Depends}
-Recommends: libxsimd-dev (>= 8.0.3~) [amd64 kfreebsd-any]
+Recommends: libxsimd-dev (>= 10.0.0~)
 Suggests: xtensor-doc <!nodoc>
 Breaks: xtensor-dev (<< 0.22.0-4~)
 Replaces: xtensor-dev (<< 0.22.0-4~)
@@ -51,6 +51,7 @@
 
 Package: xtensor-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends},
  ${sphinxdoc:Depends},
@@ -73,7 +74,6 @@
  .
  This package provides the documentation.
 Build-Profiles: <!nodoc>
-Multi-Arch: foreign
 
 Package: xtensor-dev
 Architecture: all
